package  {
	import de.polygonal.ds.DLLNode;
	import de.polygonal.ds.DLL;
	import flash.Boot;
	public class Visibility {
		public function Visibility() : void { if( !flash.Boot.skip_constructor ) {
			this.segments = new de.polygonal.ds.DLL();
			this.endpoints = new de.polygonal.ds.DLL();
			this.open = new de.polygonal.ds.DLL();
			this.center = new Point(0.0,0.0);
			this.output = new Array();
			this.demo_intersectionsDetected = [];
			this.segments.toArray();
		}}
		
		public var segments : de.polygonal.ds.DLL;
		public var endpoints : de.polygonal.ds.DLL;
		public var center : Point;
		public var open : de.polygonal.ds.DLL;
		public var output : Array;
		public var demo_intersectionsDetected : Array;
		protected function loadEdgeOfMap(size : int,margin : int) : void {
			this.addSegment(margin,margin,margin,size - margin);
			this.addSegment(margin,size - margin,size - margin,size - margin);
			this.addSegment(size - margin,size - margin,size - margin,margin);
			this.addSegment(size - margin,margin,margin,margin);
		}
		
		public function loadMap(size : int,margin : int,blocks : Array,walls : Array) : void {
			this.segments.clear();
			this.endpoints.clear();
			this.loadEdgeOfMap(size,margin);
			{
				var _g : int = 0;
				while(_g < blocks.length) {
					var block : Block = blocks[_g];
					++_g;
					var x : Number = block.x;
					var y : Number = block.y;
					var r : Number = block.r;
					this.addSegment(x - r,y - r,x - r,y + r);
					this.addSegment(x - r,y + r,x + r,y + r);
					this.addSegment(x + r,y + r,x + r,y - r);
					this.addSegment(x + r,y - r,x - r,y - r);
				}
			};
			{
				var _g1 : int = 0;
				while(_g1 < walls.length) {
					var wall : Segment = walls[_g1];
					++_g1;
					this.addSegment(wall.p1.x,wall.p1.y,wall.p2.x,wall.p2.y);
				}
			}
		}
		
		protected function addSegment(x1 : Number,y1 : Number,x2 : Number,y2 : Number) : void {
			var segment : Segment = null;
			var p1 : EndPoint = new EndPoint(0.0,0.0);
			p1.segment = segment;
			p1.visualize = true;
			var p2 : EndPoint = new EndPoint(0.0,0.0);
			p2.segment = segment;
			p2.visualize = false;
			segment = new Segment();
			p1.x = x1;
			p1.y = y1;
			p2.x = x2;
			p2.y = y2;
			p1.segment = segment;
			p2.segment = segment;
			segment.p1 = p1;
			segment.p2 = p2;
			segment.d = 0.0;
			this.segments.append(segment);
			this.endpoints.append(p1);
			this.endpoints.append(p2);
		}
		
		public function setLightLocation(x : Number,y : Number) : void {
			this.center.x = x;
			this.center.y = y;
			{ var $it : * = this.segments.iterator();
			while( $it.hasNext() ) { var segment : Segment = $it.next();
			{
				var dx : Number = 0.5 * (segment.p1.x + segment.p2.x) - x;
				var dy : Number = 0.5 * (segment.p1.y + segment.p2.y) - y;
				segment.d = dx * dx + dy * dy;
				segment.p1.angle = Math.atan2(segment.p1.y - y,segment.p1.x - x);
				segment.p2.angle = Math.atan2(segment.p2.y - y,segment.p2.x - x);
				var dAngle : Number = segment.p2.angle - segment.p1.angle;
				if(dAngle <= -Math.PI) dAngle += 2 * Math.PI;
				if(dAngle > Math.PI) dAngle -= 2 * Math.PI;
				segment.p1.begin = dAngle > 0.0;
				segment.p2.begin = !segment.p1.begin;
			}
			}}
		}
		
		protected function _segment_in_front_of(a : Segment,b : Segment,relativeTo : Point) : Boolean {
			var A1 : Boolean = Visibility.leftOf(a,Visibility.interpolate(b.p1,b.p2,0.01));
			var A2 : Boolean = Visibility.leftOf(a,Visibility.interpolate(b.p2,b.p1,0.01));
			var A3 : Boolean = Visibility.leftOf(a,relativeTo);
			var B1 : Boolean = Visibility.leftOf(b,Visibility.interpolate(a.p1,a.p2,0.01));
			var B2 : Boolean = Visibility.leftOf(b,Visibility.interpolate(a.p2,a.p1,0.01));
			var B3 : Boolean = Visibility.leftOf(b,relativeTo);
			if(B1 == B2 && B2 != B3) return true;
			if(A1 == A2 && A2 == A3) return true;
			if(A1 == A2 && A2 != A3) return false;
			if(B1 == B2 && B2 == B3) return false;
			this.demo_intersectionsDetected.push([a.p1,a.p2,b.p1,b.p2]);
			return false;
		}
		
		public function sweep(maxAngle : Number = 999.0) : void {
			this.output = [];
			this.demo_intersectionsDetected = [];
			this.endpoints.sort(Visibility._endpoint_compare,true);
			this.open.clear();
			var beginAngle : Number = 0.0;
			{
				var _g : int = 0;
				while(_g < 2) {
					var pass : int = _g++;
					{ var $it : * = this.endpoints.iterator();
					while( $it.hasNext() ) { var p : EndPoint = $it.next();
					{
						if(pass == 1 && p.angle > maxAngle) break;
						var current_old : Segment;
						if(this.open.isEmpty()) current_old = null;
						else current_old = this.open.head.val;
						if(p.begin) {
							var node : de.polygonal.ds.DLLNode = this.open.head;
							while(node != null && this._segment_in_front_of(p.segment,node.val,this.center)) node = node.next;
							if(node == null) this.open.append(p.segment);
							else this.open.insertBefore(node,p.segment);
						}
						else this.open.remove(p.segment);
						var current_new : Segment;
						if(this.open.isEmpty()) current_new = null;
						else current_new = this.open.head.val;
						if(current_old != current_new) {
							if(pass == 1) this.addTriangle(beginAngle,p.angle,current_old);
							beginAngle = p.angle;
						}
					}
					}}
				}
			}
		}
		
		public function lineIntersection(p1 : Point,p2 : Point,p3 : Point,p4 : Point) : Point {
			var s : Number = ((p4.x - p3.x) * (p1.y - p3.y) - (p4.y - p3.y) * (p1.x - p3.x)) / ((p4.y - p3.y) * (p2.x - p1.x) - (p4.x - p3.x) * (p2.y - p1.y));
			return new Point(p1.x + s * (p2.x - p1.x),p1.y + s * (p2.y - p1.y));
		}
		
		protected function addTriangle(angle1 : Number,angle2 : Number,segment : Segment) : void {
			var p1 : Point = this.center;
			var p2 : Point = new Point(this.center.x + Math.cos(angle1),this.center.y + Math.sin(angle1));
			var p3 : Point = new Point(0.0,0.0);
			var p4 : Point = new Point(0.0,0.0);
			if(segment != null) {
				p3.x = segment.p1.x;
				p3.y = segment.p1.y;
				p4.x = segment.p2.x;
				p4.y = segment.p2.y;
			}
			else {
				p3.x = this.center.x + Math.cos(angle1) * 500;
				p3.y = this.center.y + Math.sin(angle1) * 500;
				p4.x = this.center.x + Math.cos(angle2) * 500;
				p4.y = this.center.y + Math.sin(angle2) * 500;
			};
			var pBegin : Point = this.lineIntersection(p3,p4,p1,p2);
			p2.x = this.center.x + Math.cos(angle2);
			p2.y = this.center.y + Math.sin(angle2);
			var pEnd : Point = this.lineIntersection(p3,p4,p1,p2);
			this.output.push(pBegin);
			this.output.push(pEnd);
		}
		
		static protected function _endpoint_compare(a : EndPoint,b : EndPoint) : int {
			if(a.angle > b.angle) return 1;
			if(a.angle < b.angle) return -1;
			if(!a.begin && b.begin) return 1;
			if(a.begin && !b.begin) return -1;
			return 0;
		}
		
		static protected function leftOf(s : Segment,p : Point) : Boolean {
			var cross : Number = (s.p2.x - s.p1.x) * (p.y - s.p1.y) - (s.p2.y - s.p1.y) * (p.x - s.p1.x);
			return cross < 0;
		}
		
		static protected function interpolate(p : Point,q : Point,f : Number) : Point {
			return new Point(p.x * (1 - f) + q.x * f,p.y * (1 - f) + q.y * f);
		}
		
	}
}
