package de.polygonal.ds {
	public class ArrayUtil {
		static public function alloc(x : int) : Array {
			var a : Array;
			a = new Array(x);
			return a;
		}
		
		static public function shrink(a : Array,x : int) : Array {
			if(a.length > x) a.length = x;
			return a;
		}
		
		static public function copy(src : Array,dst : Array,min : int = 0,max : int = -1) : Array {
			if(max == -1) max = src.length;
			var j : int = 0;
			{
				var _g : int = min;
				while(_g < int(max)) {
					var i : int = _g++;
					dst[j++] = src[i];
				}
			};
			return dst;
		}
		
		static public function fill(dst : Array,x : *,k : int = -1) : void {
			if(k == -1) k = dst.length;
			{
				var _g : int = 0;
				while(_g < int(k)) {
					var i : int = _g++;
					dst[i] = x;
				}
			}
		}
		
		static public function assign(dst : Array,C : Class,args : Array = null,k : int = -1) : void {
			if(k == -1) k = dst.length;
			if(args == null) args = [];
			{
				var _g : int = 0;
				while(_g < int(k)) {
					var i : int = _g++;
					dst[i] = Type.createInstance(C,args);
				}
			}
		}
		
		static public function memmove(a : Array,destination : int,source : int,n : int) : void {
			if(source == destination) return;
			else if(source <= destination) {
				var i : int = source + n;
				var j : int = destination + n;
				{
					var _g : int = 0;
					while(_g < n) {
						var k : int = _g++;
						i--;
						j--;
						a[j] = a[i];
					}
				}
			}
			else {
				var i1 : int = source;
				var j1 : int = destination;
				{
					var _g1 : int = 0;
					while(_g1 < n) {
						var k1 : int = _g1++;
						a[j1] = a[i1];
						i1++;
						j1++;
					}
				}
			}
		}
		
		static public function bsearchComparator(a : Array,x : *,min : int,max : int,comparator : Function) : int {
			var l : int = min;
			var m : int;
			var h : int = max + 1;
			while(l < h) {
				m = l + (h - l >> 1);
				if(comparator(a[m],x) < 0) l = m + 1;
				else h = m;
			};
			if(l <= max && comparator(a[l],x) == 0) return l;
			else return ~l;
			return 0;
		}
		
		static public function bsearchInt(a : Array,x : int,min : int,max : int) : int {
			var l : int = min;
			var m : int;
			var h : int = max + 1;
			while(l < h) {
				m = l + (h - l >> 1);
				if(a[m] < x) l = m + 1;
				else h = m;
			};
			if(l <= max && a[l] == x) return l;
			else return ~l;
			return 0;
		}
		
		static public function bsearchFloat(a : Array,x : Number,min : int,max : int) : int {
			var l : int = min;
			var m : int;
			var h : int = max + 1;
			while(l < h) {
				m = l + (h - l >> 1);
				if(a[m] < x) l = m + 1;
				else h = m;
			};
			if(l <= max && a[l] == x) return l;
			else return ~l;
			return 0;
		}
		
		static public function shuffle(a : Array,rval : Array = null) : void {
			var s : int = a.length;
			if(rval == null) {
				var m : * = Math;
				while(--s > 1) {
					var i : int = Std._int(m.random() * s);
					var t : * = a[s];
					a[s] = a[i];
					a[i] = t;
				}
			}
			else {
				var j : int = 0;
				while(--s > 1) {
					var i1 : int = Std._int(rval[j++] * s);
					var t1 : * = a[s];
					a[s] = a[i1];
					a[i1] = t1;
				}
			}
		}
		
		static public function sortRange(a : Array,compare : Function,useInsertionSort : Boolean,first : int,count : int) : void {
			var k : int = a.length;
			if(k > 1) {
				if(useInsertionSort) de.polygonal.ds.ArrayUtil._insertionSort(a,first,count,compare);
				else de.polygonal.ds.ArrayUtil._quickSort(a,first,count,compare);
			}
		}
		
		static public function quickPerm(n : int) : Array {
			var results : Array = [];
			var a : Array = [];
			var p : Array = [];
			var i : int;
			var j : int;
			var tmp : int;
			{
				var _g : int = 0;
				while(_g < n) {
					var i1 : int = _g++;
					a[i1] = i1 + 1;
					p[i1] = 0;
				}
			};
			results.push(a.copy());
			i = 1;
			while(i < n) if(p[i] < i) {
				j = i % 2 * p[i];
				tmp = a[j];
				a[j] = a[i];
				a[i] = tmp;
				results.push(a.copy());
				p[i]++;
				i = 1;
			}
			else {
				p[i] = 0;
				i++;
			};
			return results;
		}
		
		static public function equals(a : Array,b : Array) : Boolean {
			if(a.length != b.length) return false;
			{
				var _g1 : int = 0;
				var _g : int = a.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					if(a[i] != b[i]) return false;
				}
			};
			return true;
		}
		
		static public function split(a : Array,n : int,k : int) : Array {
			var output : Array = new Array();
			var b : Array = null;
			{
				var _g : int = 0;
				while(_g < n) {
					var i : int = _g++;
					if(i % k == 0) output[Std._int(i / k)] = b = [];
					b.push(a[i]);
				}
			};
			return output;
		}
		
		static protected function _insertionSort(a : Array,first : int,k : int,cmp : Function) : void {
			var _g1 : int = first + 1;
			var _g : int = first + k;
			while(_g1 < _g) {
				var i : int = _g1++;
				var x : Number = a[i];
				var j : int = i;
				while(j > first) {
					var y : Number = a[j - 1];
					if(cmp(y,x) > 0) {
						a[j] = y;
						j--;
					}
					else break;
				};
				a[j] = x;
			}
		}
		
		static protected function _quickSort(a : Array,first : int,k : int,cmp : Function) : void {
			var last : int = first + k - 1;
			var lo : int = first;
			var hi : int = last;
			if(k > 1) {
				var i0 : int = first;
				var i1 : int = i0 + (k >> 1);
				var i2 : int = i0 + k - 1;
				var t0 : Number = a[i0];
				var t1 : Number = a[i1];
				var t2 : Number = a[i2];
				var mid : int;
				var t : int = cmp(t0,t2);
				if(t < 0 && cmp(t0,t1) < 0) if(cmp(t1,t2) < 0) mid = i1;
				else mid = i2;
				else if(cmp(t1,t0) < 0 && cmp(t1,t2) < 0) if(t < 0) mid = i0;
				else mid = i2;
				else if(cmp(t2,t0) < 0) mid = i1;
				else mid = i0;
				var pivot : Number = a[mid];
				a[mid] = a[first];
				while(lo < hi) {
					while(cmp(pivot,a[hi]) < 0 && lo < hi) hi--;
					if(hi != lo) {
						a[lo] = a[hi];
						lo++;
					};
					while(cmp(pivot,a[lo]) > 0 && lo < hi) lo++;
					if(hi != lo) {
						a[hi] = a[lo];
						hi--;
					}
				};
				a[lo] = pivot;
				de.polygonal.ds.ArrayUtil._quickSort(a,first,lo - first,cmp);
				de.polygonal.ds.ArrayUtil._quickSort(a,lo + 1,last - lo,cmp);
			}
		}
		
	}
}
