package de.polygonal.ds {
	import de.polygonal.ds.Itr;
	import de.polygonal.ds.Cloneable;
	import de.polygonal.ds.DAIterator;
	import de.polygonal.ds.ArrayUtil;
	import de.polygonal.ds.HashKey;
	import de.polygonal.ds.Comparable;
	import de.polygonal.Printf;
	import flash.Boot;
	import de.polygonal.ds.Collection;
	public class DA implements de.polygonal.ds.Collection{
		public function DA(reservedSize : int = 0,maxSize : int = -1) : void { if( !flash.Boot.skip_constructor ) {
			this._size = 0;
			this._iterator = null;
			this.maxSize = -1;
			if(reservedSize > 0) this._a = de.polygonal.ds.ArrayUtil.alloc(reservedSize);
			else this._a = new Array();
			this.key = de.polygonal.ds.HashKey.next();
			this.reuseIterator = false;
		}}
		
		public var key : int;
		protected var _a : Array;
		public var _size : int;
		protected var _iterator : de.polygonal.ds.DAIterator;
		public var maxSize : int;
		public var reuseIterator : Boolean;
		public function pack() : void {
			var s : int = this._a.length;
			if(s == this.size()) return;
			var tmp : Array = this._a;
			this._a = de.polygonal.ds.ArrayUtil.alloc(this.size());
			{
				var _g1 : int = 0;
				var _g : int = this.size();
				while(_g1 < _g) {
					var i : int = _g1++;
					this.__set(i,tmp[i]);
				}
			};
			{
				var _g11 : int = this.size();
				var _g2 : int = tmp.length;
				while(_g11 < _g2) {
					var i1 : int = _g11++;
					tmp[i1] = null;
				}
			}
		}
		
		public function reserve(x : int) : void {
			if(this.size() == x) return;
			var tmp : Array = this._a;
			this._a = de.polygonal.ds.ArrayUtil.alloc(x);
			if(this.size() < x) {
				var _g1 : int = 0;
				var _g : int = this.size();
				while(_g1 < _g) {
					var i : int = _g1++;
					this._a[i] = tmp[i];
				}
			}
		}
		
		public function trim(x : int) : void {
			this._size = x;
		}
		
		public function get(i : int) : * {
			return this.__get(i);
		}
		
		public function getNext(i : int) : * {
			return this.__get(((i + 1 == this._size)?0:i + 1));
		}
		
		public function getPrev(i : int) : * {
			return this.__get(((i - 1 == -1)?this._size - 1:i - 1));
		}
		
		public function set(i : int,x : *) : void {
			this.__set(i,x);
			if(i >= this._size) this._size++;
		}
		
		public function swp(i : int,j : int) : void {
			var tmp : * = this.get(i);
			this.cpy(i,j);
			this.set(j,tmp);
		}
		
		public function cpy(i : int,j : int) : void {
			this.set(i,this.get(j));
		}
		
		public function front() : * {
			return this.get(0);
		}
		
		public function back() : * {
			return this.get(this._size - 1);
		}
		
		public function popBack() : * {
			var x : * = this.get(this._size - 1);
			this._size--;
			return x;
		}
		
		public function pushBack(x : *) : void {
			this.set(this._size,x);
		}
		
		public function popFront() : * {
			return this.removeAt(0);
		}
		
		public function pushFront(x : *) : void {
			this.insertAt(0,x);
		}
		
		public function insertAt(i : int,x : *) : void {
			var p : int = this._size;
			while(p > i) this.__cpy(p--,p);
			this.__set(i,x);
			this._size++;
		}
		
		public function removeAt(i : int) : * {
			var x : * = this.__get(i);
			var k : int = this.size() - 1;
			var p : int = i;
			while(p < k) this.__cpy(p++,p);
			this._size--;
			return x;
		}
		
		public function swapPop(i : int) : void {
			this.__set(i,this.__get(--this._size));
		}
		
		public function removeRange(i : int,n : int,output : de.polygonal.ds.DA = null) : de.polygonal.ds.DA {
			if(output == null) {
				var s : int = this.size();
				var p : int = i + n;
				while(p < s) {
					this.__set(p - n,this.__get(p));
					p++;
				}
			}
			else {
				var s1 : int = this.size();
				var p1 : int = i + n;
				var e : *;
				var j : int;
				while(p1 < s1) {
					j = p1 - n;
					e = this.__get(j);
					output.pushBack(e);
					this.__cpy(j,p1++);
				}
			};
			this._size -= n;
			return output;
		}
		
		public function concat(x : de.polygonal.ds.DA,copy : Boolean = false) : de.polygonal.ds.DA {
			if(copy) {
				var copy1 : de.polygonal.ds.DA = new de.polygonal.ds.DA();
				copy1._size = this.size() + x.size();
				{
					var _g1 : int = 0;
					var _g : int = this.size();
					while(_g1 < _g) {
						var i : int = _g1++;
						copy1.set(i,this.__get(i));
					}
				};
				{
					var _g11 : int = this.size();
					var _g2 : int = this.size() + x.size();
					while(_g11 < _g2) {
						var i1 : int = _g11++;
						copy1.set(i1,x.get(i1 - this.size()));
					}
				};
				return copy1;
			}
			else {
				var j : int = this._size;
				this._size += x.size();
				{
					var _g12 : int = 0;
					var _g3 : int = x.size();
					while(_g12 < _g3) {
						var i2 : int = _g12++;
						this.__set(j++,x.get(i2));
					}
				};
				return this;
			};
			return null;
		}
		
		public function indexOf(x : *,from : int = 0,binarySearch : Boolean = false,comparator : Function = null) : int {
			if(this.size() == 0) return -1;
			else if(binarySearch) {
				if(comparator != null) return de.polygonal.ds.ArrayUtil.bsearchComparator(this._a,x,from,this.size() - 1,comparator);
				else {
					var k : int = this.size();
					var l : int = from;
					var m : int;
					var h : int = k;
					while(l < h) {
						m = l + (h - l >> 1);
						if(((function($this:DA) : de.polygonal.ds.Comparable {
							var $r : de.polygonal.ds.Comparable;
							var $t : * = $this._a[m];
							if(Std._is($t,de.polygonal.ds.Comparable)) (($t) as de.polygonal.ds.Comparable);
							else throw "Class cast error";
							$r = $t;
							return $r;
						}(this))).compare(x) < 0) l = m + 1;
						else h = m;
					};
					if(l <= k && ((function($this:DA) : de.polygonal.ds.Comparable {
						var $r2 : de.polygonal.ds.Comparable;
						var $t : * = $this._a[l];
						if(Std._is($t,de.polygonal.ds.Comparable)) (($t) as de.polygonal.ds.Comparable);
						else throw "Class cast error";
						$r2 = $t;
						return $r2;
					}(this))).compare(x) == 0) return l;
					else return -l;
				}
			}
			else {
				var i : int = from;
				var j : int = -1;
				var k1 : int = this.size() - 1;
				do if(this.__get(i) == x) {
					j = i;
					break;
				} while(i++ < k1);
				return j;
			};
			return 0;
		}
		
		public function lastIndexOf(x : *,from : int = -1) : int {
			if(this.size() == 0) return -1;
			else {
				if(from < 0) from = this.size() + from;
				var j : int = -1;
				var i : int = from;
				do if(this.__get(i) == x) {
					j = i;
					break;
				} while(i-- > 0);
				return j;
			};
			return 0;
		}
		
		public function reverse() : void {
			if(this._a.length > this.size()) this._a = de.polygonal.ds.ArrayUtil.shrink(this._a,this.size());
			this._a.reverse();
		}
		
		public function assign(C : Class,args : Array = null,n : int = 0) : void {
			if(n > 0) this._size = n;
			else n = this.size();
			if(args == null) args = [];
			{
				var _g : int = 0;
				while(_g < int(n)) {
					var i : int = _g++;
					this.__set(i,Type.createInstance(C,args));
				}
			}
		}
		
		public function fill(x : *,n : int = 0) : de.polygonal.ds.DA {
			if(n > 0) this._size = n;
			else n = this.size();
			{
				var _g : int = 0;
				while(_g < int(n)) {
					var i : int = _g++;
					this.__set(i,x);
				}
			};
			return this;
		}
		
		public function memmove(destination : int,source : int,n : int) : void {
			if(source == destination) return;
			else if(source <= destination) {
				var i : int = source + n;
				var j : int = destination + n;
				{
					var _g : int = 0;
					while(_g < n) {
						var k : int = _g++;
						i--;
						j--;
						this.__set(j,this.__get(i));
					}
				}
			}
			else {
				var i1 : int = source;
				var j1 : int = destination;
				{
					var _g1 : int = 0;
					while(_g1 < n) {
						var k1 : int = _g1++;
						this.__set(j1,this.__get(i1));
						i1++;
						j1++;
					}
				}
			}
		}
		
		public function join(x : String) : String {
			if(this.size() == 0) return "";
			if(this.size() == 1) return Std.string(this.front());
			var s : String = Std.string(this.front()) + x;
			{
				var _g1 : int = 1;
				var _g : int = this.size() - 1;
				while(_g1 < _g) {
					var i : int = _g1++;
					s += Std.string(this.get(i));
					s += x;
				}
			};
			s += Std.string(this.back());
			return s;
		}
		
		public function sort(compare : Function,useInsertionSort : Boolean = false,first : int = 0,count : int = -1) : void {
			if(this.size() > 1) {
				if(count == -1) count = this.size() - first;
				if(compare == null) {
					if(useInsertionSort) this._insertionSortComparable(first,count);
					else this._quickSortComparable(first,count);
				}
				else if(useInsertionSort) this._insertionSort(first,count,compare);
				else if(first == 0 && count == this.size()) {
					de.polygonal.ds.ArrayUtil.shrink(this._a,this.size());
					this._a.sort(compare);
				}
				else this._quickSort(first,count,compare);
			}
		}
		
		public function inRange(i : int) : Boolean {
			return i >= 0 && i < this._size;
		}
		
		public function getArray() : Array {
			return this._a;
		}
		
		public function free() : void {
			{
				var _g1 : int = 0;
				var _g : int = this._a.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					this.__set(i,null);
				}
			};
			this._a = null;
			this._iterator = null;
		}
		
		public function contains(x : *) : Boolean {
			var found : Boolean = false;
			{
				var _g1 : int = 0;
				var _g : int = this.size();
				while(_g1 < _g) {
					var i : int = _g1++;
					if(this.__get(i) == x) {
						found = true;
						break;
					}
				}
			};
			return found;
		}
		
		public function remove(x : *) : Boolean {
			if(this.isEmpty()) return false;
			var i : int = 0;
			var s : int = this.size();
			while(i < s) {
				if(this.__get(i) == x) {
					s--;
					var p : int = i;
					while(p < s) {
						this.__cpy(p,p + 1);
						++p;
					};
					continue;
				};
				i++;
			};
			var found : Boolean = this.size() - s != 0;
			this._size = s;
			return found;
		}
		
		public function clear(purge : Boolean = false) : void {
			if(purge) {
				var _g1 : int = 0;
				var _g : int = this._a.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					this.__set(i,null);
				}
			};
			this._size = 0;
		}
		
		public function iterator() : de.polygonal.ds.Itr {
			if(this.reuseIterator) {
				if(this._iterator == null) this._iterator = new de.polygonal.ds.DAIterator(this);
				else this._iterator.reset();
				return this._iterator;
			}
			else return new de.polygonal.ds.DAIterator(this);
			return null;
		}
		
		public function size() : int {
			return this._size;
		}
		
		public function isEmpty() : Boolean {
			return this.size() == 0;
		}
		
		public function toArray() : Array {
			var a : Array = de.polygonal.ds.ArrayUtil.alloc(this.size());
			{
				var _g1 : int = 0;
				var _g : int = this.size();
				while(_g1 < _g) {
					var i : int = _g1++;
					a[i] = this.__get(i);
				}
			};
			return a;
		}
		
		public function toVector() : Vector.<*> {
			var a : Vector.<*> = new Vector.<*>(this.size());
			{
				var _g1 : int = 0;
				var _g : int = this.size();
				while(_g1 < _g) {
					var i : int = _g1++;
					a[i] = this.__get(i);
				}
			};
			return a;
		}
		
		public function clone(assign : Boolean = true,copier : Function = null) : de.polygonal.ds.Collection {
			var copy : de.polygonal.ds.DA = new de.polygonal.ds.DA(this.size(),this.maxSize);
			copy._size = this._size;
			if(assign) {
				var _g1 : int = 0;
				var _g : int = this.size();
				while(_g1 < _g) {
					var i : int = _g1++;
					copy.__set(i,this.__get(i));
				}
			}
			else if(copier == null) {
				var c : de.polygonal.ds.Cloneable = null;
				{
					var _g11 : int = 0;
					var _g2 : int = this.size();
					while(_g11 < _g2) {
						var i1 : int = _g11++;
						c = (function($this:DA) : de.polygonal.ds.Cloneable {
							var $r : de.polygonal.ds.Cloneable;
							var $t : * = $this.__get(i1);
							if(Std._is($t,de.polygonal.ds.Cloneable)) (($t) as de.polygonal.ds.Cloneable);
							else throw "Class cast error";
							$r = $t;
							return $r;
						}(this));
						copy.__set(i1,c.clone());
					}
				}
			}
			else {
				var _g12 : int = 0;
				var _g3 : int = this.size();
				while(_g12 < _g3) {
					var i2 : int = _g12++;
					copy.__set(i2,copier(this.__get(i2)));
				}
			};
			return copy;
		}
		
		public function shuffle(rval : de.polygonal.ds.DA = null) : void {
			var s : int = this.size();
			if(rval == null) {
				var m : * = Math;
				while(--s > 1) {
					var i : int = Std._int(m.random() * s);
					var t : * = this.__get(s);
					this.__cpy(s,i);
					this.__set(i,t);
				}
			}
			else {
				var j : int = 0;
				while(--s > 1) {
					var i1 : int = Std._int(rval.get(j++) * s);
					var t1 : * = this.__get(s);
					this.__cpy(s,i1);
					this.__set(i1,t1);
				}
			}
		}
		
		public function toString() : String {
			var s : String = "{ DA size: " + this.size() + " }";
			if(this.isEmpty()) return s;
			s += "\n[\n";
			{
				var _g1 : int = 0;
				var _g : int = this.size();
				while(_g1 < _g) {
					var i : int = _g1++;
					s += de.polygonal.Printf.format("  %4d -> %s\n",[i,Std.string(this.__get(i))]);
				}
			};
			s += "]";
			return s;
		}
		
		protected function _quickSort(first : int,k : int,cmp : Function) : void {
			var last : int = first + k - 1;
			var lo : int = first;
			var hi : int = last;
			if(k > 1) {
				var i0 : int = first;
				var i1 : int = i0 + (k >> 1);
				var i2 : int = i0 + k - 1;
				var t0 : * = this.__get(i0);
				var t1 : * = this.__get(i1);
				var t2 : * = this.__get(i2);
				var mid : int;
				var t : int = cmp(t0,t2);
				if(t < 0 && cmp(t0,t1) < 0) if(cmp(t1,t2) < 0) mid = i1;
				else mid = i2;
				else if(cmp(t1,t0) < 0 && cmp(t1,t2) < 0) if(t < 0) mid = i0;
				else mid = i2;
				else if(cmp(t2,t0) < 0) mid = i1;
				else mid = i0;
				var pivot : * = this.__get(mid);
				this.__cpy(mid,first);
				while(lo < hi) {
					while(cmp(pivot,this.__get(hi)) < 0 && lo < hi) hi--;
					if(hi != lo) {
						this.__cpy(lo,hi);
						lo++;
					};
					while(cmp(pivot,this.__get(lo)) > 0 && lo < hi) lo++;
					if(hi != lo) {
						this.__cpy(hi,lo);
						hi--;
					}
				};
				this.__set(lo,pivot);
				this._quickSort(first,lo - first,cmp);
				this._quickSort(lo + 1,last - lo,cmp);
			}
		}
		
		protected function _quickSortComparable(first : int,k : int) : void {
			var last : int = first + k - 1;
			var lo : int = first;
			var hi : int = last;
			if(k > 1) {
				var i0 : int = first;
				var i1 : int = i0 + (k >> 1);
				var i2 : int = i0 + k - 1;
				var t0 : *;
				t0 = (function($this:DA) : de.polygonal.ds.Comparable {
					var $r : de.polygonal.ds.Comparable;
					var $t : * = $this.__get(i0);
					if(Std._is($t,de.polygonal.ds.Comparable)) (($t) as de.polygonal.ds.Comparable);
					else throw "Class cast error";
					$r = $t;
					return $r;
				}(this));
				var t1 : *;
				t1 = (function($this:DA) : de.polygonal.ds.Comparable {
					var $r2 : de.polygonal.ds.Comparable;
					var $t : * = $this.__get(i1);
					if(Std._is($t,de.polygonal.ds.Comparable)) (($t) as de.polygonal.ds.Comparable);
					else throw "Class cast error";
					$r2 = $t;
					return $r2;
				}(this));
				var t2 : *;
				t2 = (function($this:DA) : de.polygonal.ds.Comparable {
					var $r3 : de.polygonal.ds.Comparable;
					var $t : * = $this.__get(i2);
					if(Std._is($t,de.polygonal.ds.Comparable)) (($t) as de.polygonal.ds.Comparable);
					else throw "Class cast error";
					$r3 = $t;
					return $r3;
				}(this));
				var mid : int;
				var t : int = t0.compare(t2);
				if(t < 0 && t0.compare(t1) < 0) if(t1.compare(t2) < 0) mid = i1;
				else mid = i2;
				else if(t0.compare(t1) < 0 && t1.compare(t2) < 0) if(t < 0) mid = i0;
				else mid = i2;
				else if(t2.compare(t0) < 0) mid = i1;
				else mid = i0;
				var pivot : *;
				pivot = (function($this:DA) : de.polygonal.ds.Comparable {
					var $r4 : de.polygonal.ds.Comparable;
					var $t : * = $this.__get(mid);
					if(Std._is($t,de.polygonal.ds.Comparable)) (($t) as de.polygonal.ds.Comparable);
					else throw "Class cast error";
					$r4 = $t;
					return $r4;
				}(this));
				this.__cpy(mid,first);
				while(lo < hi) {
					while(pivot.compare((function($this:DA) : de.polygonal.ds.Comparable {
						var $r5 : de.polygonal.ds.Comparable;
						var $t : * = $this.__get(hi);
						if(Std._is($t,de.polygonal.ds.Comparable)) (($t) as de.polygonal.ds.Comparable);
						else throw "Class cast error";
						$r5 = $t;
						return $r5;
					}(this))) < 0 && lo < hi) hi--;
					if(hi != lo) {
						this.__cpy(lo,hi);
						lo++;
					};
					while(pivot.compare((function($this:DA) : de.polygonal.ds.Comparable {
						var $r6 : de.polygonal.ds.Comparable;
						var $t : * = $this.__get(lo);
						if(Std._is($t,de.polygonal.ds.Comparable)) (($t) as de.polygonal.ds.Comparable);
						else throw "Class cast error";
						$r6 = $t;
						return $r6;
					}(this))) > 0 && lo < hi) lo++;
					if(hi != lo) {
						this.__cpy(hi,lo);
						hi--;
					}
				};
				this.__set(lo,pivot);
				this._quickSortComparable(first,lo - first);
				this._quickSortComparable(lo + 1,last - lo);
			}
		}
		
		protected function _insertionSort(first : int,k : int,cmp : Function) : void {
			var _g1 : int = first + 1;
			var _g : int = first + k;
			while(_g1 < _g) {
				var i : int = _g1++;
				var x : * = this.__get(i);
				var j : int = i;
				while(j > first) {
					var y : * = this.__get(j - 1);
					if(cmp(y,x) > 0) {
						this.__set(j,y);
						j--;
					}
					else break;
				};
				this.__set(j,x);
			}
		}
		
		protected function _insertionSortComparable(first : int,k : int) : void {
			var _g1 : int = first + 1;
			var _g : int = first + k;
			while(_g1 < _g) {
				var i : int = _g1++;
				var x : * = this.__get(i);
				var j : int = i;
				while(j > first) {
					var y : * = this.__get(j - 1);
					if(((function($this:DA) : de.polygonal.ds.Comparable {
						var $r : de.polygonal.ds.Comparable;
						var $t : * = y;
						if(Std._is($t,de.polygonal.ds.Comparable)) (($t) as de.polygonal.ds.Comparable);
						else throw "Class cast error";
						$r = $t;
						return $r;
					}(this))).compare(x) > 0) {
						this.__set(j,y);
						j--;
					}
					else break;
				};
				this.__set(j,x);
			}
		}
		
		protected function __get(i : int) : * {
			return this._a[i];
		}
		
		public function __set(i : int,x : *) : void {
			this._a[i] = x;
		}
		
		protected function __cpy(i : int,j : int) : void {
			this._a[i] = this._a[j];
		}
		
	}
}
