package de.polygonal.ds {
	import de.polygonal.ds.DLL;
	import flash.Boot;
	public class DLLNode {
		public function DLLNode(x : * = null,list : de.polygonal.ds.DLL = null) : void { if( !flash.Boot.skip_constructor ) {
			this.val = x;
			this._list = list;
		}}
		
		public var val : *;
		public var next : de.polygonal.ds.DLLNode;
		public var prev : de.polygonal.ds.DLLNode;
		protected var _list : de.polygonal.ds.DLL;
		public function free() : void {
			this.val = null;
			this.next = this.prev = null;
			this._list = null;
		}
		
		public function isHead() : Boolean {
			return this == this._list.head;
		}
		
		public function isTail() : Boolean {
			return this == this._list.tail;
		}
		
		public function hasNext() : Boolean {
			return this.next != null;
		}
		
		public function hasPrev() : Boolean {
			return this.prev != null;
		}
		
		public function nextVal() : * {
			return this.next.val;
		}
		
		public function prevVal() : * {
			return this.prev.val;
		}
		
		public function getList() : de.polygonal.ds.DLL {
			return this._list;
		}
		
		public function unlink() : de.polygonal.ds.DLLNode {
			return this._list.unlink(this);
		}
		
		public function prepend(node : de.polygonal.ds.DLLNode) : de.polygonal.ds.DLLNode {
			node.next = this;
			this.prev = node;
			return node;
		}
		
		public function append(node : de.polygonal.ds.DLLNode) : de.polygonal.ds.DLLNode {
			this.next = node;
			node.prev = this;
			return node;
		}
		
		public function prependTo(node : de.polygonal.ds.DLLNode) : de.polygonal.ds.DLLNode {
			this.next = node;
			if(node != null) node.prev = this;
			return this;
		}
		
		public function appendTo(node : de.polygonal.ds.DLLNode) : de.polygonal.ds.DLLNode {
			this.prev = node;
			if(node != null) node.next = this;
			return this;
		}
		
		public function toString() : String {
			return "{ DLLNode " + Std.string(this.val) + " }";
		}
		
		protected function _unlink() : de.polygonal.ds.DLLNode {
			var t : de.polygonal.ds.DLLNode = this.next;
			if(this.hasPrev()) this.prev.next = this.next;
			if(this.hasNext()) this.next.prev = this.prev;
			this.next = this.prev = null;
			return t;
		}
		
		protected function _insertAfter(node : de.polygonal.ds.DLLNode) : void {
			node.next = this.next;
			node.prev = this;
			if(this.hasNext()) this.next.prev = node;
			this.next = node;
		}
		
		protected function _insertBefore(node : de.polygonal.ds.DLLNode) : void {
			node.next = this;
			node.prev = this.prev;
			if(this.hasPrev()) this.prev.next = node;
			this.prev = node;
		}
		
	}
}
